'''
Compute the Satake invariants of the hyperelliptic curve y^2=f(x)
'''
def SatakeInvariants(a0,a1,a2,a3,a4,a5=1,a6=0,verbose=false):
  R.<x>=QQ[]
  poly=a0+a1*x+a2*x^2+a3*x^3+a4*x^4+a5*x^5+a6*x^6
  I2,I4,I6,I10=igusa_clebsch_invariants(poly);
  if(verbose):
    print("Polynomial defining the curve", poly);
    print("Igusa-Clebsch invariants", I2,I4,I6,I10);
  chi10=-2^(-14)*I10;
  chi12=I2*I10/(2^17*3);
  psi4=2^(-2)*I4;
  psi6=2^(-3)*(I2*I4-3*I6);
  s2=12*psi4;
  s3=12*psi6;
  s5=60*psi4*psi6-2^14*3^5*5*chi10;
  s6=108*psi4^3+24*psi6^2+2^15*3^7*chi12;
  if(verbose):
    print("Satake coordinates:", s2,s3,s5,s6);
  return s2,s3,s5,s6;
